#import <collections.h>

#define __USE_FIXED_PROTOTYPES__   // for gcc headers
#include <stdio.h>

int main( void )
{
  id  aZone, s1, s2, s3, t1, FooBarString, s4;

  initModule( collections );

  aZone = [Zone create: globalZone];

  t1 = [String customizeBegin: aZone];
  [t1 setC: "foobar"];
  FooBarString = [t1 customizeEnd];
  printf( "FooBarString id is: %0#8x\n", (unsigned int)FooBarString );
  [FooBarString drop];
  [aZone xprint];
  if ( _obj_debug ) exit(0);

  s1 = [String create: aZone setC: "abcdef"];
  printf( "string is: %s\n", [s1 getC] );
  [s1 setC: "foo"];
  printf( "string is: %s\n", [s1 getC] );
  [s1 catC: "bar"];
  printf( "string is: %s\n", [s1 getC] );
  [s1 drop];

  s2 = [String create: aZone];
  [s2 setC: ""];
  printf( "string is: %s\n", [s2 getC] );
  [s2 catC: "foo"];
  printf( "string is: %s\n", [s2 getC] );
  [s2 drop];

  s3 = [String create: aZone];
  printf( "string is: %s\n", [s3 getC] );
  [s3 catC: "foo"];
  printf( "string is: %s\n", [s3 getC] );
  s4 = [s3 perform: @selector( copy: ) with: aZone];
  [s4 catC: "FOO"];
  printf( "string is: %s\n", [s4 getC] );
  [s3 drop];
  [s4 drop];
  [aZone xprint];

  t1 = [String customizeBegin: aZone];
  [t1 setC: "foobar"];
  FooBarString = [t1 customizeEnd];
  printf( "FooBarString id is: %0#8x\n", (unsigned int)FooBarString );
  [FooBarString drop];
  [aZone xprint];
  if ( _obj_debug ) exit(0);

  s4 = [FooBarString create: aZone];
  printf( "string is: %s  id is: %0#8x\n", [s4 getC], (unsigned int)s4 );
  [s4 catC: "foo"];
  printf( "string is: %s\n", [s4 getC] );

  s1 = [OutputStream create: scratchZone setFileStream: _obj_xdebug];
  [s1 catC: "output string\n"];
  [s1 drop];

  s1 = [OutputStream createBegin: scratchZone];
  [s1 setFileStream: _obj_xdebug];
  s1 = [s1 createEnd];
  [s1 catC: "output string\n"];
  [s1 drop];

  [s4 xprint];
  [s4 setC: "long output string that just keeps going and going and going\n"];
  [s4 xprint];
  [s4 drop];
  [FooBarString xprint];
  [FooBarString drop];
  [aZone xprint];
  [aZone drop];
  return 0;
}
